function demo2(I1, I2, D1, D2)
   % nonmax suppress
   fbr1 = double(D1.gpb_all)./255;
   fbr2 = double(D2.gpb_all)./255;
   angs = [1/2 3/8 1/4 1/8 0 7/8 3/4 5/8]*180;
   for o=1:length(angs)
      fbr1(:,:,o) = nonmax(fbr1(:,:,o),angs(o));
      fbr2(:,:,o) = nonmax(fbr1(:,:,o),angs(o));
   end
   % rs are the radii for sample points
   rs =      [0 4 8 16 32 50];
   % nthetas are the number of samples at each radii
   nthetas = [1 8 8 10 12 12];
   % alpha is the rate of increase for blur
   alpha = 0.5;
   % beta is the base blur amount
   beta = 1;
   % Number of descriptors to extract per image
   ndescriptors = 1000;
   % repulsion radius for rejection sampling
   rrep = 3;
   % Actually extract Geometric Blur descriptors for each image
   [descriptors1, pos1] = get_descriptors2(fbr1,ndescriptors,rrep,alpha,beta,rs,nthetas, double(D1.ucm_m)./255);
   [descriptors2, pos2] = get_descriptors2(fbr2,ndescriptors,rrep,alpha,beta,rs,nthetas, double(D2.ucm_m)./255);
   % compute dissimilarity between features
   diss = -comp_features(descriptors1,descriptors2);
   sample_points = compute_sample_points(rs,nthetas);
   % Interactively show the best match for points on the model,
   % click on a point in the left (model) image to see its similarity
   % to each point on the right image, with the best match marked with
   % a magenta star
   vis_gb_match(I1, pos1, I2, pos2, descriptors1, descriptors2, diss, sample_points)
end
