%% Get n clicks within the specified image limits.
function [xs ys buttons] = ginput_range(im_size, n)
   if (nargin < 2), n = 1; end
   curr = 1;
   xs = zeros([n 1]);
   ys = zeros([n 1]);
   buttons = zeros([n 1]);
   while (curr <= n)
      [y x b] = ginput(1);
      x = round(x);
      y = round(y);
      if (~((x < 1) || (x > im_size(1)) || ...
            (y < 1) || (y > im_size(2))))
         xs(curr) = x;
         ys(curr) = y;
         buttons(curr) = b;
         curr = curr + 1;
      end
   end
end
